from SystemEntity import SystemEntity
from Link import Link
import csv
from Node import Node
from OverlayNode import OverlayNode
import logging
logger = logging.getLogger(__name__)




class Network():
    def __init__(self):
        self.nodes = {}#{1 : Node(1),2:Node(2)}
        self.links = {} #{(1,2):Link(1-2),(2,1):Link(2,1),(3,2):Link(3*2)}      linkID = tuple(1,2)
        self.networkClockTime = 0

    def setupNetwork(self):
        '''
        Assumption : nodes are unique
                    links are unique and bidirectional
                    no errorneous nodes present in the file
                    no erroneous link present in the file
                    self loops are not there

        Adds links and nodes to the network .It is a one time activity.

        :return:
        '''

        with open('Nodes.dat', 'r') as f:
            reader = csv.reader(f)
            for row in reader:
                node = row[0] # tuple of a link
                self.nodes.update({node:OverlayNode(node,self)})
                # print(self.nodes.get('1')) #keys are strings


        with open('Links.dat', 'r') as f:
            reader = csv.reader(f)
            for row in reader:
                link = tuple(row[0].split()) # tuple of a link
                linkDelay = 1
                self.links.update({link:Link(link,self,linkDelay)})

                # adding adjacent nodes list to each node
                self.nodes.get(link[0]).adjacentNodes.append(link[1])
                self.nodes.get(link[1]).adjacentNodes.append(link[0])
                # print(self.links.get(('1', '2'))) #keys are strings


        pass


    def simulate(self,time):
        # logger.info("simulating .. ")
        self.networkClockTime = time
        # Note links should be simulated before nodes
        #  in order to receive the messge which is supposed to be received in this tick
        for link in self.links.values():
            link.simulate(time)

        for node in self.nodes.values():
            node.simulate(time)

        pass

if __name__ == '__main__':
    network = Network()
    network.setupNetwork()

    pass
